src/Entity/Species.php
<?php

namespace App\Entity;

use ApiPlatform\Metadata;
use ApiPlatform\Metadata\ApiResource;
use App\Repository\SpeciesRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Serializer\Attribute\Groups;
use Symfony\Component\Validator\Constraints as Assert;

#[ORM\Entity(repositoryClass: SpeciesRepository::class)]
#[ApiResource(
    operations: [new Metadata\Post(), new Metadata\Get(), new Metadata\Put(), new Metadata\Delete(), new Metadata\Patch()],
    normalizationContext: ['groups' => ['species:collection:read', 'species:read']],
)]
#[Metadata\GetCollection(normalizationContext: ['groups' => ['species:collection:read']])]
class Species
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    #[Groups(['species:collection:read'])]
    private ?int $id = null;

    #[ORM\Column(length: 255)]
    #[Groups(['species:collection:read'])]
    #[Assert\NotBlank]
    private ?string $scientific_name = null;

    #[ORM\Column(length: 255)]
    #[Groups(['species:collection:read'])]
    #[Assert\NotBlank]
    private ?string $vernacular_name = null;

    #[ORM\Column(length: 255)]
    #[Groups(['species:collection:read'])]
    #[Assert\NotBlank]
    private ?string $region = null;

    /**
     * @var Collection<int, Post>
     */
    #[ORM\OneToMany(targetEntity: Post::class, mappedBy: 'species')]
    #[Groups(['species:read'])]
    private Collection $posts;

    public function __construct()
    {
        $this->posts = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getScientificName(): ?string
    {
        return $this->scientific_name;
    }

    public function setScientificName(string $scientific_name): static
    {
        $this->scientific_name = $scientific_name;

        return $this;
    }

    public function getVernacularName(): ?string
    {
        return $this->vernacular_name;
    }

    public function setVernacularName(string $vernacular_name): static
    {
        $this->vernacular_name = $vernacular_name;

        return $this;
    }

    public function getRegion(): ?string
    {
        return $this->region;
    }

    public function setRegion(string $region): static
    {
        $this->region = $region;

        return $this;
    }

    /**
     * @return Collection<int, Post>
     */
    public function getPosts(): Collection
    {
        return $this->posts;
    }

    public function addPost(Post $post): static
    {
        if (!$this->posts->contains($post)) {
            $this->posts->add($post);
            $post->setSpecies($this);
        }

        return $this;
    }

    public function removePost(Post $post): static
    {
        if ($this->posts->removeElement($post)) {
            // set the owning side to null (unless already changed)
            if ($post->getSpecies() === $this) {
                $post->setSpecies(null);
            }
        }

        return $this;
    }
}

src/Form/SpeciesType.php
<?php

namespace App\Form;

use App\Entity\Species;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class SpeciesType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('scientific_name')
            ->add('vernacular_name')
            ->add('region')
        ;
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Species::class,
        ]);
    }
}

src/Controller/SpeciesController.php
<?php

namespace App\Controller;

use App\Entity\Species;
use App\Form\SpeciesType;
use App\Repository\SpeciesRepository;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Attribute\Route;
use Symfony\Component\Security\Http\Attribute\IsGranted;

#[Route('/species')]
class SpeciesController extends AbstractController
{
    #[Route('/', name: 'app_species_index', methods: ['GET'])]
    public function table(SpeciesRepository $speciesRepository): Response
    {
        return $this->render('species/index.html.twig', [
            'species' => $speciesRepository->findAll(),
        ]);
    }

    #[Route('/new', name: 'app_species_new', methods: ['GET', 'POST'])]
    #[IsGranted('ROLE_USER')]
    public function new(Request $request, EntityManagerInterface $entityManager): Response
    {
        $species = new Species();
        $form = $this->createForm(SpeciesType::class, $species);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager->persist($species);
            $entityManager->flush();

            return $this->redirectToRoute('app_species_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->render('species/new.html.twig', [
            'species' => $species,
            'form' => $form,
        ]);
    }

    #[Route('/{id}', name: 'app_species_show', methods: ['GET'])]
    public function show(Species $species): Response
    {
        return $this->render('species/show.html.twig', [
            'species' => $species,
        ]);
    }

    #[Route('/{id}/edit', name: 'app_species_edit', methods: ['GET', 'POST'])]
    #[IsGranted('ROLE_USER')]
    public function edit(Request $request, Species $species, EntityManagerInterface $entityManager): Response
    {
        $form = $this->createForm(SpeciesType::class, $species);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager->flush();

            return $this->redirectToRoute('app_species_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->render('species/edit.html.twig', [
            'species' => $species,
            'form' => $form,
        ]);
    }

    #[Route('/{id}', name: 'app_species_delete', methods: ['POST'])]
    #[IsGranted('ROLE_USER')]
    public function delete(Request $request, Species $species, EntityManagerInterface $entityManager): Response
    {
        if ($this->isCsrfTokenValid('delete'.$species->getId(), (string) $request->getPayload()->get('_token'))) {
            $entityManager->remove($species);
            $entityManager->flush();
        }

        return $this->redirectToRoute('app_species_index', [], Response::HTTP_SEE_OTHER);
    }
}

templates/species/_delete_form.html.twig
<form method="post" action="{{ path('app_species_delete', {'id': species.id}) }}" onsubmit="return confirm('{{ 'delete_item_confirmation'|trans }}');">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ species.id) }}">
    <button class="btn btn-danger">{{ 'delete'|trans }}</button>
</form>

templates/species/_form.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
    <button class="btn btn-primary">{{ button_label|default('save'|trans) }}</button>
{{ form_end(form) }}

templates/species/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}{{ 'edit_species'|trans }}{% endblock %}

{% block body %}
    <h1>{{ 'edit_species'|trans }}</h1>
    {{ include('species/_form.html.twig', {'button_label': 'update'|trans}) }}

    <a class="btn btn-warning mb-4 mt-4" href="{{ path('app_species_index') }}">{{ 'back_to_list'|trans }}</a>

    {{ include('species/_delete_form.html.twig') }}
{% endblock %}

templates/species/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}{{ 'species'|trans }}{% endblock %}

{% block body %}
<style>
    .example-wrapper { margin: 1em auto; max-width: 800px; width: 95%; font: 18px/1.5 sans-serif; }
    .example-wrapper code { background: #F5F5F5; padding: 2px 6px; }
</style>

<div class="example-wrapper">
    <h1>{{ 'list_of_species'|trans }}</h1>

    <dl>
        {% for specie in species %}
            <dt>
                <a href={{ path('app_species_show', {'id': specie.id}) }}>
                🌿 {{ specie.vernacularName }}
                </a>
            </dt>
            <dd >
                🔬 {{ 'scientific_name'|trans }} : {{ specie.scientificName }}<br/>
                📍 {{ 'region'|trans }} : {{ specie.region }}
            </dd><br/>
        {% endfor %}
    </dl>

    <a href="{{ path('app_species_new') }}">{{ 'create_new'|trans }}</a>
</div>
{% endblock %}

templates/species/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New Species{% endblock %}

{% block body %}
    <h1>{{ 'create_new_species'|trans }}</h1>

    {{ include('species/_form.html.twig') }}

    <a class="btn btn-warning mb-4 mt-4" href="{{ path('app_species_index') }}">{{ 'back_to_list'|trans }}</a>
{% endblock %}

templates/species/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}{{ 'species'|trans }}{% endblock %}

{% block body %}
<h1>{{ species.vernacularName }}</h1>
<p>
    🔬  {{ 'scientific_name'|trans }} : {{ species.scientificName }}<br/>
    📍 {{ 'region'|trans }} : {{ species.region }}
</p>

<div>
    <h2>{{ 'posts'|trans }} :</h2>

    {% for post in species.posts %}
        <div>
            <dt>
                <h3>{{ post.publicationDate | date }}</h3>
            </dt>
            <dl>
                <dt>📍{{ 'geolocation'|trans }}</dt>
                <dd>{{ post.longitude }} - {{ post.latitude }}</dd>

                <dt>💬{{ 'commentary'|trans }}</dt>
                <dd>{{ post.getCommentary }}</dd>
            </dl>
        </div>
    {% endfor %}

    <a class="btn btn-warning mb-4 mt-4" href="{{ path('app_species_index') }}">{{ 'back_to_list'|trans }}</a>

    <a class="btn btn-success mb-4 mt-4" href="{{ path('app_species_edit', {'id': species.id}) }}">{{ 'edit'|trans }}</a>

    {{ include('species/_delete_form.html.twig') }}
</div>
{% endblock %}

templates/species/table.html.twig
{% extends 'base.html.twig' %}

{% block title %}{{ 'species_index'|trans }}{% endblock %}

{% block body %}
    <h1>{{ 'species_index'|trans }}</h1>

    <table class="table">
        <thead>
        <tr>
            <th>Id</th>
            <th>{{ 'scientific_name'|trans }}</th>
            <th>{{ 'vernacular_name'|trans }}</th>
            <th>{{ 'region'|trans }}</th>
            <th>Actions</th>
        </tr>
        </thead>
        <tbody>
        {% for species in species %}
            <tr>
                <td>{{ species.id }}</td>
                <td>{{ species.scientificName }}</td>
                <td>{{ species.vernacularName }}</td>
                <td>{{ species.region }}</td>
                <td>
                    <a href="{{ path('app_species_show', {'id': species.id}) }}">{{ 'show'|trans }}</a>
                    <a href="{{ path('app_species_edit', {'id': species.id}) }}">{{ 'edit'|trans }}</a>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="5">{{ 'no_records_found'|trans }}</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>

    <a href="{{ path('app_species_new') }}">{{ 'create_new'|trans }}</a>
{% endblock %}